package io.syndesis.server.controller.integration.camelk.crd;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.common.base.MoreObjects;
import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.errorprone.annotations.Var;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Objects;
import javax.annotation.CheckReturnValue;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link ConfigurationSpec}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new ConfigurationSpec.Builder()}.
 */
@Generated(from = "ConfigurationSpec", generator = "Immutables")
@SuppressWarnings({"ArrayEquals", "ArrayHashCode", "ArrayToString", "all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
@CheckReturnValue
public final class ImmutableConfigurationSpec
    implements ConfigurationSpec {
  private final @Nullable String type;
  private final @Nullable String value;

  private ImmutableConfigurationSpec(@Nullable String type, @Nullable String value) {
    this.type = type;
    this.value = value;
  }

  /**
   * @return The value of the {@code type} attribute
   */
  @JsonProperty("type")
  @Override
  public @Nullable String getType() {
    return type;
  }

  /**
   * @return The value of the {@code value} attribute
   */
  @JsonProperty("value")
  @Override
  public @Nullable String getValue() {
    return value;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link ConfigurationSpec#getType() type} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for type (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableConfigurationSpec withType(@Nullable String value) {
    if (Objects.equals(this.type, value)) return this;
    return new ImmutableConfigurationSpec(value, this.value);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link ConfigurationSpec#getValue() value} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for value (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableConfigurationSpec withValue(@Nullable String value) {
    if (Objects.equals(this.value, value)) return this;
    return new ImmutableConfigurationSpec(this.type, value);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableConfigurationSpec} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableConfigurationSpec
        && equalTo((ImmutableConfigurationSpec) another);
  }

  private boolean equalTo(ImmutableConfigurationSpec another) {
    return Objects.equals(type, another.type)
        && Objects.equals(value, another.value);
  }

  /**
   * Computes a hash code from attributes: {@code type}, {@code value}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    @Var int h = 5381;
    h += (h << 5) + Objects.hashCode(type);
    h += (h << 5) + Objects.hashCode(value);
    return h;
  }

  /**
   * Prints the immutable value {@code ConfigurationSpec} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return MoreObjects.toStringHelper("ConfigurationSpec")
        .omitNullValues()
        .add("type", type)
        .add("value", value)
        .toString();
  }

  /**
   * Creates an immutable copy of a {@link ConfigurationSpec} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable ConfigurationSpec instance
   */
  public static ImmutableConfigurationSpec copyOf(ConfigurationSpec instance) {
    if (instance instanceof ImmutableConfigurationSpec) {
      return (ImmutableConfigurationSpec) instance;
    }
    return new ConfigurationSpec.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link ImmutableConfigurationSpec ImmutableConfigurationSpec}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "ConfigurationSpec", generator = "Immutables")
  @NotThreadSafe
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class Builder {
    private @Nullable String type;
    private @Nullable String value;

    /**
     * Creates a builder for {@link ImmutableConfigurationSpec ImmutableConfigurationSpec} instances.
     * <pre>
     * new ConfigurationSpec.Builder()
     *    .type(String | null) // nullable {@link ConfigurationSpec#getType() type}
     *    .value(String | null) // nullable {@link ConfigurationSpec#getValue() value}
     *    .build();
     * </pre>
     */
    public Builder() {
      if (!(this instanceof ConfigurationSpec.Builder)) {
        throw new UnsupportedOperationException("Use: new ConfigurationSpec.Builder()");
      }
    }

    /**
     * Fill a builder with attribute values from the provided {@code ConfigurationSpec} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final ConfigurationSpec.Builder from(ConfigurationSpec instance) {
      Objects.requireNonNull(instance, "instance");
      @Nullable String typeValue = instance.getType();
      if (typeValue != null) {
        type(typeValue);
      }
      @Nullable String valueValue = instance.getValue();
      if (valueValue != null) {
        value(valueValue);
      }
      return (ConfigurationSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link ConfigurationSpec#getType() type} attribute.
     * @param type The value for type (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("type")
    public final ConfigurationSpec.Builder type(@Nullable String type) {
      this.type = type;
      return (ConfigurationSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link ConfigurationSpec#getValue() value} attribute.
     * @param value The value for value (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("value")
    public final ConfigurationSpec.Builder value(@Nullable String value) {
      this.value = value;
      return (ConfigurationSpec.Builder) this;
    }

    /**
     * Builds a new {@link ImmutableConfigurationSpec ImmutableConfigurationSpec}.
     * @return An immutable instance of ConfigurationSpec
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableConfigurationSpec build() {
      return new ImmutableConfigurationSpec(type, value);
    }
  }
}
