package io.syndesis.server.controller.integration.camelk.crd;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.common.base.MoreObjects;
import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.errorprone.annotations.Var;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Objects;
import javax.annotation.CheckReturnValue;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link DataSpec}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new DataSpec.Builder()}.
 */
@Generated(from = "DataSpec", generator = "Immutables")
@SuppressWarnings({"ArrayEquals", "ArrayHashCode", "ArrayToString", "all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
@CheckReturnValue
public final class ImmutableDataSpec implements DataSpec {
  private final @Nullable String name;
  private final @Nullable String content;
  private final @Nullable String contentRef;
  private final @Nullable String contentKey;
  private final @Nullable Boolean compression;

  private ImmutableDataSpec(
      @Nullable String name,
      @Nullable String content,
      @Nullable String contentRef,
      @Nullable String contentKey,
      @Nullable Boolean compression) {
    this.name = name;
    this.content = content;
    this.contentRef = contentRef;
    this.contentKey = contentKey;
    this.compression = compression;
  }

  /**
   * @return The value of the {@code name} attribute
   */
  @JsonProperty("name")
  @Override
  public @Nullable String getName() {
    return name;
  }

  /**
   * @return The value of the {@code content} attribute
   */
  @JsonProperty("content")
  @Override
  public @Nullable String getContent() {
    return content;
  }

  /**
   * @return The value of the {@code contentRef} attribute
   */
  @JsonProperty("contentRef")
  @Override
  public @Nullable String getContentRef() {
    return contentRef;
  }

  /**
   * @return The value of the {@code contentKey} attribute
   */
  @JsonProperty("contentKey")
  @Override
  public @Nullable String getContentKey() {
    return contentKey;
  }

  /**
   * @return The value of the {@code compression} attribute
   */
  @JsonProperty("compression")
  @Override
  public @Nullable Boolean getCompression() {
    return compression;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link DataSpec#getName() name} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for name (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableDataSpec withName(@Nullable String value) {
    if (Objects.equals(this.name, value)) return this;
    return new ImmutableDataSpec(value, this.content, this.contentRef, this.contentKey, this.compression);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link DataSpec#getContent() content} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for content (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableDataSpec withContent(@Nullable String value) {
    if (Objects.equals(this.content, value)) return this;
    return new ImmutableDataSpec(this.name, value, this.contentRef, this.contentKey, this.compression);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link DataSpec#getContentRef() contentRef} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for contentRef (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableDataSpec withContentRef(@Nullable String value) {
    if (Objects.equals(this.contentRef, value)) return this;
    return new ImmutableDataSpec(this.name, this.content, value, this.contentKey, this.compression);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link DataSpec#getContentKey() contentKey} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for contentKey (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableDataSpec withContentKey(@Nullable String value) {
    if (Objects.equals(this.contentKey, value)) return this;
    return new ImmutableDataSpec(this.name, this.content, this.contentRef, value, this.compression);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link DataSpec#getCompression() compression} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for compression (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableDataSpec withCompression(@Nullable Boolean value) {
    if (Objects.equals(this.compression, value)) return this;
    return new ImmutableDataSpec(this.name, this.content, this.contentRef, this.contentKey, value);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableDataSpec} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableDataSpec
        && equalTo((ImmutableDataSpec) another);
  }

  private boolean equalTo(ImmutableDataSpec another) {
    return Objects.equals(name, another.name)
        && Objects.equals(content, another.content)
        && Objects.equals(contentRef, another.contentRef)
        && Objects.equals(contentKey, another.contentKey)
        && Objects.equals(compression, another.compression);
  }

  /**
   * Computes a hash code from attributes: {@code name}, {@code content}, {@code contentRef}, {@code contentKey}, {@code compression}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    @Var int h = 5381;
    h += (h << 5) + Objects.hashCode(name);
    h += (h << 5) + Objects.hashCode(content);
    h += (h << 5) + Objects.hashCode(contentRef);
    h += (h << 5) + Objects.hashCode(contentKey);
    h += (h << 5) + Objects.hashCode(compression);
    return h;
  }

  /**
   * Prints the immutable value {@code DataSpec} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return MoreObjects.toStringHelper("DataSpec")
        .omitNullValues()
        .add("name", name)
        .add("content", content)
        .add("contentRef", contentRef)
        .add("contentKey", contentKey)
        .add("compression", compression)
        .toString();
  }

  /**
   * Creates an immutable copy of a {@link DataSpec} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable DataSpec instance
   */
  public static ImmutableDataSpec copyOf(DataSpec instance) {
    if (instance instanceof ImmutableDataSpec) {
      return (ImmutableDataSpec) instance;
    }
    return new DataSpec.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link ImmutableDataSpec ImmutableDataSpec}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "DataSpec", generator = "Immutables")
  @NotThreadSafe
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class Builder {
    private @Nullable String name;
    private @Nullable String content;
    private @Nullable String contentRef;
    private @Nullable String contentKey;
    private @Nullable Boolean compression;

    /**
     * Creates a builder for {@link ImmutableDataSpec ImmutableDataSpec} instances.
     * <pre>
     * new DataSpec.Builder()
     *    .name(String | null) // nullable {@link DataSpec#getName() name}
     *    .content(String | null) // nullable {@link DataSpec#getContent() content}
     *    .contentRef(String | null) // nullable {@link DataSpec#getContentRef() contentRef}
     *    .contentKey(String | null) // nullable {@link DataSpec#getContentKey() contentKey}
     *    .compression(Boolean | null) // nullable {@link DataSpec#getCompression() compression}
     *    .build();
     * </pre>
     */
    public Builder() {
      if (!(this instanceof DataSpec.Builder)) {
        throw new UnsupportedOperationException("Use: new DataSpec.Builder()");
      }
    }

    /**
     * Fill a builder with attribute values from the provided {@code DataSpec} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final DataSpec.Builder from(DataSpec instance) {
      Objects.requireNonNull(instance, "instance");
      @Nullable String nameValue = instance.getName();
      if (nameValue != null) {
        name(nameValue);
      }
      @Nullable String contentValue = instance.getContent();
      if (contentValue != null) {
        content(contentValue);
      }
      @Nullable String contentRefValue = instance.getContentRef();
      if (contentRefValue != null) {
        contentRef(contentRefValue);
      }
      @Nullable String contentKeyValue = instance.getContentKey();
      if (contentKeyValue != null) {
        contentKey(contentKeyValue);
      }
      @Nullable Boolean compressionValue = instance.getCompression();
      if (compressionValue != null) {
        compression(compressionValue);
      }
      return (DataSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link DataSpec#getName() name} attribute.
     * @param name The value for name (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("name")
    public final DataSpec.Builder name(@Nullable String name) {
      this.name = name;
      return (DataSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link DataSpec#getContent() content} attribute.
     * @param content The value for content (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("content")
    public final DataSpec.Builder content(@Nullable String content) {
      this.content = content;
      return (DataSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link DataSpec#getContentRef() contentRef} attribute.
     * @param contentRef The value for contentRef (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("contentRef")
    public final DataSpec.Builder contentRef(@Nullable String contentRef) {
      this.contentRef = contentRef;
      return (DataSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link DataSpec#getContentKey() contentKey} attribute.
     * @param contentKey The value for contentKey (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("contentKey")
    public final DataSpec.Builder contentKey(@Nullable String contentKey) {
      this.contentKey = contentKey;
      return (DataSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link DataSpec#getCompression() compression} attribute.
     * @param compression The value for compression (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("compression")
    public final DataSpec.Builder compression(@Nullable Boolean compression) {
      this.compression = compression;
      return (DataSpec.Builder) this;
    }

    /**
     * Builds a new {@link ImmutableDataSpec ImmutableDataSpec}.
     * @return An immutable instance of DataSpec
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableDataSpec build() {
      return new ImmutableDataSpec(name, content, contentRef, contentKey, compression);
    }
  }
}
