package io.syndesis.server.controller.integration.camelk.crd;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.common.base.MoreObjects;
import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.errorprone.annotations.Var;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Objects;
import javax.annotation.CheckReturnValue;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link Failure}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new Failure.Builder()}.
 */
@Generated(from = "Failure", generator = "Immutables")
@SuppressWarnings({"ArrayEquals", "ArrayHashCode", "ArrayToString", "all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
@CheckReturnValue
public final class ImmutableFailure implements Failure {
  private final @Nullable String reason;
  private final @Nullable String time;
  private final @Nullable FailureRecovery recovery;

  private ImmutableFailure(
      @Nullable String reason,
      @Nullable String time,
      @Nullable FailureRecovery recovery) {
    this.reason = reason;
    this.time = time;
    this.recovery = recovery;
  }

  /**
   * @return The value of the {@code reason} attribute
   */
  @JsonProperty("reason")
  @Override
  public @Nullable String getReason() {
    return reason;
  }

  /**
   * @return The value of the {@code time} attribute
   */
  @JsonProperty("time")
  @Override
  public @Nullable String getTime() {
    return time;
  }

  /**
   * @return The value of the {@code recovery} attribute
   */
  @JsonProperty("recovery")
  @Override
  public @Nullable FailureRecovery getRecovery() {
    return recovery;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link Failure#getReason() reason} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for reason (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableFailure withReason(@Nullable String value) {
    if (Objects.equals(this.reason, value)) return this;
    return new ImmutableFailure(value, this.time, this.recovery);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link Failure#getTime() time} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for time (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableFailure withTime(@Nullable String value) {
    if (Objects.equals(this.time, value)) return this;
    return new ImmutableFailure(this.reason, value, this.recovery);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link Failure#getRecovery() recovery} attribute.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for recovery (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableFailure withRecovery(@Nullable FailureRecovery value) {
    if (this.recovery == value) return this;
    return new ImmutableFailure(this.reason, this.time, value);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableFailure} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableFailure
        && equalTo((ImmutableFailure) another);
  }

  private boolean equalTo(ImmutableFailure another) {
    return Objects.equals(reason, another.reason)
        && Objects.equals(time, another.time)
        && Objects.equals(recovery, another.recovery);
  }

  /**
   * Computes a hash code from attributes: {@code reason}, {@code time}, {@code recovery}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    @Var int h = 5381;
    h += (h << 5) + Objects.hashCode(reason);
    h += (h << 5) + Objects.hashCode(time);
    h += (h << 5) + Objects.hashCode(recovery);
    return h;
  }

  /**
   * Prints the immutable value {@code Failure} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return MoreObjects.toStringHelper("Failure")
        .omitNullValues()
        .add("reason", reason)
        .add("time", time)
        .add("recovery", recovery)
        .toString();
  }

  /**
   * Creates an immutable copy of a {@link Failure} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable Failure instance
   */
  public static ImmutableFailure copyOf(Failure instance) {
    if (instance instanceof ImmutableFailure) {
      return (ImmutableFailure) instance;
    }
    return new Failure.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link ImmutableFailure ImmutableFailure}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "Failure", generator = "Immutables")
  @NotThreadSafe
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class Builder {
    private @Nullable String reason;
    private @Nullable String time;
    private @Nullable FailureRecovery recovery;

    /**
     * Creates a builder for {@link ImmutableFailure ImmutableFailure} instances.
     * <pre>
     * new Failure.Builder()
     *    .reason(String | null) // nullable {@link Failure#getReason() reason}
     *    .time(String | null) // nullable {@link Failure#getTime() time}
     *    .recovery(io.syndesis.server.controller.integration.camelk.crd.FailureRecovery | null) // nullable {@link Failure#getRecovery() recovery}
     *    .build();
     * </pre>
     */
    public Builder() {
      if (!(this instanceof Failure.Builder)) {
        throw new UnsupportedOperationException("Use: new Failure.Builder()");
      }
    }

    /**
     * Fill a builder with attribute values from the provided {@code Failure} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final Failure.Builder from(Failure instance) {
      Objects.requireNonNull(instance, "instance");
      @Nullable String reasonValue = instance.getReason();
      if (reasonValue != null) {
        reason(reasonValue);
      }
      @Nullable String timeValue = instance.getTime();
      if (timeValue != null) {
        time(timeValue);
      }
      @Nullable FailureRecovery recoveryValue = instance.getRecovery();
      if (recoveryValue != null) {
        recovery(recoveryValue);
      }
      return (Failure.Builder) this;
    }

    /**
     * Initializes the value for the {@link Failure#getReason() reason} attribute.
     * @param reason The value for reason (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("reason")
    public final Failure.Builder reason(@Nullable String reason) {
      this.reason = reason;
      return (Failure.Builder) this;
    }

    /**
     * Initializes the value for the {@link Failure#getTime() time} attribute.
     * @param time The value for time (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("time")
    public final Failure.Builder time(@Nullable String time) {
      this.time = time;
      return (Failure.Builder) this;
    }

    /**
     * Initializes the value for the {@link Failure#getRecovery() recovery} attribute.
     * @param recovery The value for recovery (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("recovery")
    public final Failure.Builder recovery(@Nullable FailureRecovery recovery) {
      this.recovery = recovery;
      return (Failure.Builder) this;
    }

    /**
     * Builds a new {@link ImmutableFailure ImmutableFailure}.
     * @return An immutable instance of Failure
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableFailure build() {
      return new ImmutableFailure(reason, time, recovery);
    }
  }
}
