package io.syndesis.server.controller.integration.camelk.crd;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.common.base.MoreObjects;
import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.errorprone.annotations.Var;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Objects;
import javax.annotation.CheckReturnValue;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link FailureRecovery}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new FailureRecovery.Builder()}.
 */
@Generated(from = "FailureRecovery", generator = "Immutables")
@SuppressWarnings({"ArrayEquals", "ArrayHashCode", "ArrayToString", "all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
@CheckReturnValue
public final class ImmutableFailureRecovery
    implements FailureRecovery {
  private final @Nullable Integer attempt;
  private final @Nullable Integer attemptMax;
  private final @Nullable String attemptTime;

  private ImmutableFailureRecovery(
      @Nullable Integer attempt,
      @Nullable Integer attemptMax,
      @Nullable String attemptTime) {
    this.attempt = attempt;
    this.attemptMax = attemptMax;
    this.attemptTime = attemptTime;
  }

  /**
   * @return The value of the {@code attempt} attribute
   */
  @JsonProperty("attempt")
  @Override
  public @Nullable Integer getAttempt() {
    return attempt;
  }

  /**
   * @return The value of the {@code attemptMax} attribute
   */
  @JsonProperty("attemptMax")
  @Override
  public @Nullable Integer getAttemptMax() {
    return attemptMax;
  }

  /**
   * @return The value of the {@code attemptTime} attribute
   */
  @JsonProperty("attemptTime")
  @Override
  public @Nullable String getAttemptTime() {
    return attemptTime;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link FailureRecovery#getAttempt() attempt} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for attempt (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableFailureRecovery withAttempt(@Nullable Integer value) {
    if (Objects.equals(this.attempt, value)) return this;
    return new ImmutableFailureRecovery(value, this.attemptMax, this.attemptTime);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link FailureRecovery#getAttemptMax() attemptMax} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for attemptMax (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableFailureRecovery withAttemptMax(@Nullable Integer value) {
    if (Objects.equals(this.attemptMax, value)) return this;
    return new ImmutableFailureRecovery(this.attempt, value, this.attemptTime);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link FailureRecovery#getAttemptTime() attemptTime} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for attemptTime (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableFailureRecovery withAttemptTime(@Nullable String value) {
    if (Objects.equals(this.attemptTime, value)) return this;
    return new ImmutableFailureRecovery(this.attempt, this.attemptMax, value);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableFailureRecovery} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableFailureRecovery
        && equalTo((ImmutableFailureRecovery) another);
  }

  private boolean equalTo(ImmutableFailureRecovery another) {
    return Objects.equals(attempt, another.attempt)
        && Objects.equals(attemptMax, another.attemptMax)
        && Objects.equals(attemptTime, another.attemptTime);
  }

  /**
   * Computes a hash code from attributes: {@code attempt}, {@code attemptMax}, {@code attemptTime}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    @Var int h = 5381;
    h += (h << 5) + Objects.hashCode(attempt);
    h += (h << 5) + Objects.hashCode(attemptMax);
    h += (h << 5) + Objects.hashCode(attemptTime);
    return h;
  }

  /**
   * Prints the immutable value {@code FailureRecovery} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return MoreObjects.toStringHelper("FailureRecovery")
        .omitNullValues()
        .add("attempt", attempt)
        .add("attemptMax", attemptMax)
        .add("attemptTime", attemptTime)
        .toString();
  }

  /**
   * Creates an immutable copy of a {@link FailureRecovery} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable FailureRecovery instance
   */
  public static ImmutableFailureRecovery copyOf(FailureRecovery instance) {
    if (instance instanceof ImmutableFailureRecovery) {
      return (ImmutableFailureRecovery) instance;
    }
    return new FailureRecovery.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link ImmutableFailureRecovery ImmutableFailureRecovery}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "FailureRecovery", generator = "Immutables")
  @NotThreadSafe
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class Builder {
    private @Nullable Integer attempt;
    private @Nullable Integer attemptMax;
    private @Nullable String attemptTime;

    /**
     * Creates a builder for {@link ImmutableFailureRecovery ImmutableFailureRecovery} instances.
     * <pre>
     * new FailureRecovery.Builder()
     *    .attempt(Integer | null) // nullable {@link FailureRecovery#getAttempt() attempt}
     *    .attemptMax(Integer | null) // nullable {@link FailureRecovery#getAttemptMax() attemptMax}
     *    .attemptTime(String | null) // nullable {@link FailureRecovery#getAttemptTime() attemptTime}
     *    .build();
     * </pre>
     */
    public Builder() {
      if (!(this instanceof FailureRecovery.Builder)) {
        throw new UnsupportedOperationException("Use: new FailureRecovery.Builder()");
      }
    }

    /**
     * Fill a builder with attribute values from the provided {@code FailureRecovery} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final FailureRecovery.Builder from(FailureRecovery instance) {
      Objects.requireNonNull(instance, "instance");
      @Nullable Integer attemptValue = instance.getAttempt();
      if (attemptValue != null) {
        attempt(attemptValue);
      }
      @Nullable Integer attemptMaxValue = instance.getAttemptMax();
      if (attemptMaxValue != null) {
        attemptMax(attemptMaxValue);
      }
      @Nullable String attemptTimeValue = instance.getAttemptTime();
      if (attemptTimeValue != null) {
        attemptTime(attemptTimeValue);
      }
      return (FailureRecovery.Builder) this;
    }

    /**
     * Initializes the value for the {@link FailureRecovery#getAttempt() attempt} attribute.
     * @param attempt The value for attempt (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("attempt")
    public final FailureRecovery.Builder attempt(@Nullable Integer attempt) {
      this.attempt = attempt;
      return (FailureRecovery.Builder) this;
    }

    /**
     * Initializes the value for the {@link FailureRecovery#getAttemptMax() attemptMax} attribute.
     * @param attemptMax The value for attemptMax (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("attemptMax")
    public final FailureRecovery.Builder attemptMax(@Nullable Integer attemptMax) {
      this.attemptMax = attemptMax;
      return (FailureRecovery.Builder) this;
    }

    /**
     * Initializes the value for the {@link FailureRecovery#getAttemptTime() attemptTime} attribute.
     * @param attemptTime The value for attemptTime (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("attemptTime")
    public final FailureRecovery.Builder attemptTime(@Nullable String attemptTime) {
      this.attemptTime = attemptTime;
      return (FailureRecovery.Builder) this;
    }

    /**
     * Builds a new {@link ImmutableFailureRecovery ImmutableFailureRecovery}.
     * @return An immutable instance of FailureRecovery
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableFailureRecovery build() {
      return new ImmutableFailureRecovery(attempt, attemptMax, attemptTime);
    }
  }
}
