package io.syndesis.server.controller.integration.camelk.crd;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.common.base.MoreObjects;
import com.google.common.collect.ImmutableMap;
import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.errorprone.annotations.Var;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Map;
import java.util.Objects;
import javax.annotation.CheckReturnValue;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link IntegrationTraitSpec}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new IntegrationTraitSpec.Builder()}.
 */
@Generated(from = "IntegrationTraitSpec", generator = "Immutables")
@SuppressWarnings({"ArrayEquals", "ArrayHashCode", "ArrayToString", "all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
@CheckReturnValue
public final class ImmutableIntegrationTraitSpec
    implements IntegrationTraitSpec {
  private final ImmutableMap<String, String> configuration;

  private ImmutableIntegrationTraitSpec(ImmutableIntegrationTraitSpec.Builder builder) {
    this.configuration = builder.configurationIsSet()
        ? builder.configuration.build()
        : ImmutableMap.copyOf(IntegrationTraitSpec.super.getConfiguration());
  }

  private ImmutableIntegrationTraitSpec(ImmutableMap<String, String> configuration) {
    this.configuration = configuration;
  }

  /**
   * @return The value of the {@code configuration} attribute
   */
  @JsonProperty("configuration")
  @Override
  public ImmutableMap<String, String> getConfiguration() {
    return configuration;
  }

  /**
   * Copy the current immutable object by replacing the {@link IntegrationTraitSpec#getConfiguration() configuration} map with the specified map.
   * Nulls are not permitted as keys or values.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param entries The entries to be added to the configuration map
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIntegrationTraitSpec withConfiguration(Map<String, ? extends String> entries) {
    if (this.configuration == entries) return this;
    ImmutableMap<String, String> newValue = ImmutableMap.copyOf(entries);
    return new ImmutableIntegrationTraitSpec(newValue);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableIntegrationTraitSpec} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableIntegrationTraitSpec
        && equalTo((ImmutableIntegrationTraitSpec) another);
  }

  private boolean equalTo(ImmutableIntegrationTraitSpec another) {
    return configuration.equals(another.configuration);
  }

  /**
   * Computes a hash code from attributes: {@code configuration}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    @Var int h = 5381;
    h += (h << 5) + configuration.hashCode();
    return h;
  }

  /**
   * Prints the immutable value {@code IntegrationTraitSpec} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return MoreObjects.toStringHelper("IntegrationTraitSpec")
        .omitNullValues()
        .add("configuration", configuration)
        .toString();
  }

  /**
   * Creates an immutable copy of a {@link IntegrationTraitSpec} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable IntegrationTraitSpec instance
   */
  public static ImmutableIntegrationTraitSpec copyOf(IntegrationTraitSpec instance) {
    if (instance instanceof ImmutableIntegrationTraitSpec) {
      return (ImmutableIntegrationTraitSpec) instance;
    }
    return new IntegrationTraitSpec.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link ImmutableIntegrationTraitSpec ImmutableIntegrationTraitSpec}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "IntegrationTraitSpec", generator = "Immutables")
  @NotThreadSafe
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class Builder {
    private static final long OPT_BIT_CONFIGURATION = 0x1L;
    private long optBits;

    private ImmutableMap.Builder<String, String> configuration = ImmutableMap.builder();

    /**
     * Creates a builder for {@link ImmutableIntegrationTraitSpec ImmutableIntegrationTraitSpec} instances.
     * <pre>
     * new IntegrationTraitSpec.Builder()
     *    .putConfiguration|putAllConfiguration(String =&gt; String) // {@link IntegrationTraitSpec#getConfiguration() configuration} mappings
     *    .build();
     * </pre>
     */
    public Builder() {
      if (!(this instanceof IntegrationTraitSpec.Builder)) {
        throw new UnsupportedOperationException("Use: new IntegrationTraitSpec.Builder()");
      }
    }

    /**
     * Fill a builder with attribute values from the provided {@code IntegrationTraitSpec} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * Collection elements and entries will be added, not replaced.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final IntegrationTraitSpec.Builder from(IntegrationTraitSpec instance) {
      Objects.requireNonNull(instance, "instance");
      putAllConfiguration(instance.getConfiguration());
      return (IntegrationTraitSpec.Builder) this;
    }

    /**
     * Put one entry to the {@link IntegrationTraitSpec#getConfiguration() configuration} map.
     * @param key The key in the configuration map
     * @param value The associated value in the configuration map
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final IntegrationTraitSpec.Builder putConfiguration(String key, String value) {
      this.configuration.put(key, value);
      optBits |= OPT_BIT_CONFIGURATION;
      return (IntegrationTraitSpec.Builder) this;
    }

    /**
     * Put one entry to the {@link IntegrationTraitSpec#getConfiguration() configuration} map. Nulls are not permitted
     * @param entry The key and value entry
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final IntegrationTraitSpec.Builder putConfiguration(Map.Entry<String, ? extends String> entry) {
      this.configuration.put(entry);
      optBits |= OPT_BIT_CONFIGURATION;
      return (IntegrationTraitSpec.Builder) this;
    }

    /**
     * Sets or replaces all mappings from the specified map as entries for the {@link IntegrationTraitSpec#getConfiguration() configuration} map. Nulls are not permitted
     * @param entries The entries that will be added to the configuration map
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("configuration")
    public final IntegrationTraitSpec.Builder configuration(Map<String, ? extends String> entries) {
      this.configuration = ImmutableMap.builder();
      optBits |= OPT_BIT_CONFIGURATION;
      return putAllConfiguration(entries);
    }

    /**
     * Put all mappings from the specified map as entries to {@link IntegrationTraitSpec#getConfiguration() configuration} map. Nulls are not permitted
     * @param entries The entries that will be added to the configuration map
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final IntegrationTraitSpec.Builder putAllConfiguration(Map<String, ? extends String> entries) {
      this.configuration.putAll(entries);
      optBits |= OPT_BIT_CONFIGURATION;
      return (IntegrationTraitSpec.Builder) this;
    }

    /**
     * Builds a new {@link ImmutableIntegrationTraitSpec ImmutableIntegrationTraitSpec}.
     * @return An immutable instance of IntegrationTraitSpec
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableIntegrationTraitSpec build() {
      return new ImmutableIntegrationTraitSpec(this);
    }

    private boolean configurationIsSet() {
      return (optBits & OPT_BIT_CONFIGURATION) != 0;
    }
  }
}
