package io.syndesis.server.controller.integration.camelk.crd;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonUnwrapped;
import com.google.common.base.MoreObjects;
import com.google.errorprone.annotations.CanIgnoreReturnValue;
import com.google.errorprone.annotations.Var;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Objects;
import javax.annotation.CheckReturnValue;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link SourceSpec}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new SourceSpec.Builder()}.
 */
@Generated(from = "SourceSpec", generator = "Immutables")
@SuppressWarnings({"ArrayEquals", "ArrayHashCode", "ArrayToString", "all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
@CheckReturnValue
public final class ImmutableSourceSpec
    implements SourceSpec {
  private final @Nullable DataSpec dataSpec;
  private final @Nullable String language;

  private ImmutableSourceSpec(
      @Nullable DataSpec dataSpec,
      @Nullable String language) {
    this.dataSpec = dataSpec;
    this.language = language;
  }

  /**
   * @return The value of the {@code dataSpec} attribute
   */
  @JsonProperty("dataSpec")
  @JsonUnwrapped
  @Override
  public @Nullable DataSpec getDataSpec() {
    return dataSpec;
  }

  /**
   * @return The value of the {@code language} attribute
   */
  @JsonProperty("language")
  @Override
  public @Nullable String getLanguage() {
    return language;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link SourceSpec#getDataSpec() dataSpec} attribute.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for dataSpec (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableSourceSpec withDataSpec(@Nullable DataSpec value) {
    if (this.dataSpec == value) return this;
    return new ImmutableSourceSpec(value, this.language);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link SourceSpec#getLanguage() language} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for language (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableSourceSpec withLanguage(@Nullable String value) {
    if (Objects.equals(this.language, value)) return this;
    return new ImmutableSourceSpec(this.dataSpec, value);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableSourceSpec} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableSourceSpec
        && equalTo((ImmutableSourceSpec) another);
  }

  private boolean equalTo(ImmutableSourceSpec another) {
    return Objects.equals(dataSpec, another.dataSpec)
        && Objects.equals(language, another.language);
  }

  /**
   * Computes a hash code from attributes: {@code dataSpec}, {@code language}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    @Var int h = 5381;
    h += (h << 5) + Objects.hashCode(dataSpec);
    h += (h << 5) + Objects.hashCode(language);
    return h;
  }

  /**
   * Prints the immutable value {@code SourceSpec} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return MoreObjects.toStringHelper("SourceSpec")
        .omitNullValues()
        .add("dataSpec", dataSpec)
        .add("language", language)
        .toString();
  }

  /**
   * Creates an immutable copy of a {@link SourceSpec} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable SourceSpec instance
   */
  public static ImmutableSourceSpec copyOf(SourceSpec instance) {
    if (instance instanceof ImmutableSourceSpec) {
      return (ImmutableSourceSpec) instance;
    }
    return new SourceSpec.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link ImmutableSourceSpec ImmutableSourceSpec}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "SourceSpec", generator = "Immutables")
  @NotThreadSafe
  @JsonInclude(JsonInclude.Include.NON_NULL)
  public static class Builder {
    private @Nullable DataSpec dataSpec;
    private @Nullable String language;

    /**
     * Creates a builder for {@link ImmutableSourceSpec ImmutableSourceSpec} instances.
     * <pre>
     * new SourceSpec.Builder()
     *    .dataSpec(io.syndesis.server.controller.integration.camelk.crd.DataSpec | null) // nullable {@link SourceSpec#getDataSpec() dataSpec}
     *    .language(String | null) // nullable {@link SourceSpec#getLanguage() language}
     *    .build();
     * </pre>
     */
    public Builder() {
      if (!(this instanceof SourceSpec.Builder)) {
        throw new UnsupportedOperationException("Use: new SourceSpec.Builder()");
      }
    }

    /**
     * Fill a builder with attribute values from the provided {@code SourceSpec} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    public final SourceSpec.Builder from(SourceSpec instance) {
      Objects.requireNonNull(instance, "instance");
      @Nullable DataSpec dataSpecValue = instance.getDataSpec();
      if (dataSpecValue != null) {
        dataSpec(dataSpecValue);
      }
      @Nullable String languageValue = instance.getLanguage();
      if (languageValue != null) {
        language(languageValue);
      }
      return (SourceSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link SourceSpec#getDataSpec() dataSpec} attribute.
     * @param dataSpec The value for dataSpec (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("dataSpec")
    @JsonUnwrapped
    public final SourceSpec.Builder dataSpec(@Nullable DataSpec dataSpec) {
      this.dataSpec = dataSpec;
      return (SourceSpec.Builder) this;
    }

    /**
     * Initializes the value for the {@link SourceSpec#getLanguage() language} attribute.
     * @param language The value for language (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @CanIgnoreReturnValue 
    @JsonProperty("language")
    public final SourceSpec.Builder language(@Nullable String language) {
      this.language = language;
      return (SourceSpec.Builder) this;
    }

    /**
     * Builds a new {@link ImmutableSourceSpec ImmutableSourceSpec}.
     * @return An immutable instance of SourceSpec
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableSourceSpec build() {
      return new ImmutableSourceSpec(dataSpec, language);
    }
  }
}
